privacy.h File Reference
libpurple

Privacy API. More...

`#include "account.h"`

Go to the source code of this file.

## Data Structures

struct | PurplePrivacyUiOps
| Privacy core/UI operations. More...

## Typedefs

typedef enum _PurplePrivacyType | PurplePrivacyType
| Privacy data types.

## Enumerations

enum | _PurplePrivacyType { PURPLE_PRIVACY_ALLOW_ALL = 1, PURPLE_PRIVACY_DENY_ALL, PURPLE_PRIVACY_ALLOW_USERS, PURPLE_PRIVACY_DENY_USERS, PURPLE_PRIVACY_ALLOW_BUDDYLIST }
| Privacy data types.

## Functions

gboolean | purple_privacy_permit_add (PurpleAccount *account, const char *name, gboolean local_only)
| Adds a user to the account's permit list. More...
gboolean | purple_privacy_permit_remove (PurpleAccount *account, const char *name, gboolean local_only)
| Removes a user from the account's permit list. More...
gboolean | purple_privacy_deny_add (PurpleAccount *account, const char *name, gboolean local_only)
| Adds a user to the account's deny list. More...
gboolean | purple_privacy_deny_remove (PurpleAccount *account, const char *name, gboolean local_only)
| Removes a user from the account's deny list. More...
void | purple_privacy_allow (PurpleAccount *account, const char *who, gboolean local, gboolean restore)
| Allow a user to send messages. More...
void | purple_privacy_deny (PurpleAccount *account, const char *who, gboolean local, gboolean restore)
| Block messages from a user. More...
gboolean | purple_privacy_check (PurpleAccount *account, const char *who)
| Check the privacy-setting for a user. More...
void | purple_privacy_set_ui_ops (PurplePrivacyUiOps *ops)
| Sets the UI operations structure for the privacy subsystem. More...
PurplePrivacyUiOps * | purple_privacy_get_ui_ops (void)
| Returns the UI operations structure for the privacy subsystem. More...
void | purple_privacy_init (void)
| Initializes the privacy subsystem.

## Detailed Description

Privacy API.

Definition in file privacy.h.

## Function Documentation

void purple_privacy_allow | ( | PurpleAccount * | account,
|  | const char * | who,
|  | gboolean | local,
|  | gboolean | restore
| ) |  |

Allow a user to send messages.

If current privacy setting for the account is: PURPLE_PRIVACY_ALLOW_USERS: The user is added to the allow-list. PURPLE_PRIVACY_DENY_USERS : The user is removed from the deny-list. PURPLE_PRIVACY_ALLOW_ALL : No changes made. PURPLE_PRIVACY_DENY_ALL : The privacy setting is changed to PURPLE_PRIVACY_ALLOW_USERS and the user is added to the allow-list. PURPLE_PRIVACY_ALLOW_BUDDYLIST: No changes made if the user is already in the buddy-list. Otherwise the setting is changed to PURPLE_PRIVACY_ALLOW_USERS, all the buddies are added to the allow-list, and the user is also added to the allow-list.

Parameters

  account | The account.
  who | The name of the user.
  local | Whether the change is local-only.
  restore | Should the previous allow/deny list be restored if the privacy setting is changed.

gboolean purple_privacy_check | ( | PurpleAccount * | account,
|  | const char * | who
| ) |  |

Check the privacy-setting for a user.

Parameters

  account | The account.
  who | The name of the user.

Returns
  `FALSE` if the specified account's privacy settings block the user or `TRUE` otherwise. The meaning of "block" is protocol-dependent and generally relates to status and/or sending of messages.

void purple_privacy_deny | ( | PurpleAccount * | account,
|  | const char * | who,
|  | gboolean | local,
|  | gboolean | restore
| ) |  |

Block messages from a user.

If current privacy setting for the account is: PURPLE_PRIVACY_ALLOW_USERS: The user is removed from the allow-list. PURPLE_PRIVACY_DENY_USERS : The user is added to the deny-list. PURPLE_PRIVACY_DENY_ALL : No changes made. PURPLE_PRIVACY_ALLOW_ALL : The privacy setting is changed to PURPLE_PRIVACY_DENY_USERS and the user is added to the deny-list. PURPLE_PRIVACY_ALLOW_BUDDYLIST: If the user is not in the buddy-list, then no changes made. Otherwise, the setting is changed to PURPLE_PRIVACY_ALLOW_USERS, all the buddies are added to the allow-list, and this user is removed from the list.

Parameters

  account | The account.
  who | The name of the user.
  local | Whether the change is local-only.
  restore | Should the previous allow/deny list be restored if the privacy setting is changed.

gboolean purple_privacy_deny_add | ( | PurpleAccount * | account,
|  | const char * | name,
|  | gboolean | local_only
| ) |  |

Adds a user to the account's deny list.

Parameters

  account | The account.
  name | The name of the user to add to the list.
  local_only | If TRUE, only the local list is updated, and not the server.

Returns
  TRUE if the user was added successfully, or `FALSE` otherwise.

gboolean purple_privacy_deny_remove | ( | PurpleAccount * | account,
|  | const char * | name,
|  | gboolean | local_only
| ) |  |

Removes a user from the account's deny list.

Parameters

  account | The account.
  name | The name of the user to add to the list.
  local_only | If TRUE, only the local list is updated, and not the server.

Returns
  TRUE if the user was removed successfully, or `FALSE` otherwise.

PurplePrivacyUiOps* purple_privacy_get_ui_ops | ( | void |  | ) |

Returns the UI operations structure for the privacy subsystem.

Returns
  The UI operations structure.

gboolean purple_privacy_permit_add | ( | PurpleAccount * | account,
|  | const char * | name,
|  | gboolean | local_only
| ) |  |

Adds a user to the account's permit list.

Parameters

  account | The account.
  name | The name of the user to add to the list.
  local_only | If TRUE, only the local list is updated, and not the server.

Returns
  TRUE if the user was added successfully, or `FALSE` otherwise.

gboolean purple_privacy_permit_remove | ( | PurpleAccount * | account,
|  | const char * | name,
|  | gboolean | local_only
| ) |  |

Removes a user from the account's permit list.

Parameters

  account | The account.
  name | The name of the user to add to the list.
  local_only | If TRUE, only the local list is updated, and not the server.

Returns
  TRUE if the user was removed successfully, or `FALSE` otherwise.

void purple_privacy_set_ui_ops | ( | PurplePrivacyUiOps * | ops | ) |

Sets the UI operations structure for the privacy subsystem.

Parameters

  ops | The UI operations structure.